# coding: utf-8

"""
    Karbon Platform Services API reference.

    OpenAPI documentation for public facing Karbon Platform Services API  This API documentation is generated from source code using go-swagger. Do not edit the generated kps_api.json directly!  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: karbon-platform-services-api@nutanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from kps_api.api_client import ApiClient


class SSHApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def setup_ssh_tunneling(self, body, authorization, **kwargs):  # noqa: E501
        """Configure SSH tunneling to the service domain.  # noqa: E501

        Configure SSH tunneling to the service domain. Requirements to use this feature: Minimum service domain version of 1.15.0. Remote SSH tunneling feature and CLI access are enabled per account. Service domain profile has SSH enabled.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.setup_ssh_tunneling(body, authorization, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WstunRequest body: SSH Tunneling setup request param (required)
        :param str authorization: Format: Bearer <token>, with <token> from login API response. (required)
        :return: WstunPayload
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.setup_ssh_tunneling_with_http_info(body, authorization, **kwargs)  # noqa: E501
        else:
            (data) = self.setup_ssh_tunneling_with_http_info(body, authorization, **kwargs)  # noqa: E501
            return data

    def setup_ssh_tunneling_with_http_info(self, body, authorization, **kwargs):  # noqa: E501
        """Configure SSH tunneling to the service domain.  # noqa: E501

        Configure SSH tunneling to the service domain. Requirements to use this feature: Minimum service domain version of 1.15.0. Remote SSH tunneling feature and CLI access are enabled per account. Service domain profile has SSH enabled.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.setup_ssh_tunneling_with_http_info(body, authorization, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WstunRequest body: SSH Tunneling setup request param (required)
        :param str authorization: Format: Bearer <token>, with <token> from login API response. (required)
        :return: WstunPayload
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method setup_ssh_tunneling" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `setup_ssh_tunneling`")  # noqa: E501
        # verify the required parameter 'authorization' is set
        if ('authorization' not in params or
                params['authorization'] is None):
            raise ValueError("Missing the required parameter `authorization` when calling `setup_ssh_tunneling`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BearerToken']  # noqa: E501

        return self.api_client.call_api(
            '/v1.0/setupsshtunneling', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='WstunPayload',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def teardown_ssh_tunneling(self, body, authorization, **kwargs):  # noqa: E501
        """Disable service domain SSH tunneling.  # noqa: E501

        Shut down SSH tunneling to the service domain. Disables SSH tunneling, including current open sessions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.teardown_ssh_tunneling(body, authorization, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WstunTeardownRequest body: SSH Tunneling teardown request param (required)
        :param str authorization: Format: Bearer <token>, with <token> from login API response. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.teardown_ssh_tunneling_with_http_info(body, authorization, **kwargs)  # noqa: E501
        else:
            (data) = self.teardown_ssh_tunneling_with_http_info(body, authorization, **kwargs)  # noqa: E501
            return data

    def teardown_ssh_tunneling_with_http_info(self, body, authorization, **kwargs):  # noqa: E501
        """Disable service domain SSH tunneling.  # noqa: E501

        Shut down SSH tunneling to the service domain. Disables SSH tunneling, including current open sessions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.teardown_ssh_tunneling_with_http_info(body, authorization, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WstunTeardownRequest body: SSH Tunneling teardown request param (required)
        :param str authorization: Format: Bearer <token>, with <token> from login API response. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'authorization']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method teardown_ssh_tunneling" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `teardown_ssh_tunneling`")  # noqa: E501
        # verify the required parameter 'authorization' is set
        if ('authorization' not in params or
                params['authorization'] is None):
            raise ValueError("Missing the required parameter `authorization` when calling `teardown_ssh_tunneling`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'authorization' in params:
            header_params['Authorization'] = params['authorization']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['BearerToken']  # noqa: E501

        return self.api_client.call_api(
            '/v1.0/teardownsshtunneling', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
